---
title: paint-order
slug: Web/CSS/paint-order
tags:
  - CSS
  - Reference
  - SVG
  - Web
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>paint-order</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property lets you control the order in which the fill and stroke (and painting markers) of text content and shapes are drawn.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* Normal */
paint-order: normal;

/* Single values */
paint-order: stroke; /* draw the stroke first, then fill and markers */
paint-order: markers; /* draw the markers first, then fill and stroke */

/* Multiple values */
paint-order: stroke fill; /* draw the stroke first, then the fill, then the markers */
paint-order: markers stroke fill; /* draw markers, then stroke, then fill */
</pre>

<p>If no value is specified, the default paint order is <code>fill</code>, <code>stroke</code>, <code>markers</code>.</p>

<p>When one value is specified, that one is painted first, followed by the other two in their default order relative to one another. When two values are specified, they will be painted in the order they are specified in, followed by the unspecified one.</p>

<div class="note">
<p><strong>Note</strong>: In the case of this property, markers are only appropriate when drawing SVG shapes involving the use of the <code>marker-*</code> properties (e.g. <code><a href="/en-US/docs/Web/SVG/Attribute/marker-start">marker-start</a></code>) and <code><a href="/en-US/docs/Web/SVG/Element/marker">&lt;marker&gt;</a></code> element. They do not apply to HTML text, so in that case, you can only determine the order of <code>stroke</code> and <code>fill</code>.</p>
</div>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>normal</code></dt>
 <dd>Paint the different items in normal paint order.</dd>
 <dt><code>stroke</code>,<br>
 <code>fill</code>,<br>
 <code>markers</code></dt>
 <dd>Specify some or all of these values in the order you want them to be painted in.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Reversing_the_paint_order_of_stroke_and_fill">Reversing the paint order of stroke and fill</h3>

<h4 id="SVG">SVG</h4>

<pre class="brush: html notranslate">&lt;svg xmlns="http://www.w3.org/2000/svg" width="400" height="200"&gt;
  &lt;text x="10" y="75"&gt;stroke in front&lt;/text&gt;
  &lt;text x="10" y="150" class="stroke-behind"&gt;stroke behind&lt;/text&gt;
&lt;/svg&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">text {
  font-family: sans-serif;
  font-size: 50px;
  font-weight: bold;
  fill: black;
  stroke: red;
  stroke-width: 4px;
}

.stroke-behind {
  paint-order: stroke fill;
}</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Reversing_the_paint_order_of_stroke_and_fill", "100%", 165)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG2", "painting.html#PaintOrder", "paint-order")}}</td>
   <td>{{Spec2("SVG2")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.paint-order")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://css-tricks.com/almanac/properties/p/paint-order/">CSS Tricks: paint-order</a></li>
</ul>
